/*
	This file is part of the smb library
    Copyright (C) 1999  Nicolas Brodu
    brodu@iie.cnam.fr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
class DES
{
protected:
	unsigned char key[64]; // one bit by byte, simpler algorithm...
	unsigned char K[16][48]; // one bit by byte, simpler algorithm...
	// Encrypt (encdec=0) or decrypt (encdec=1)
	void doIt(unsigned char* data, const unsigned long length, int encdec);
public:
	// key must be 56 bits
	// Anyway, the parity bits introduced in the des-how-to are discarded by the
	// first permutation function
	DES(const unsigned char* key=0);
	~DES();
	void setKey(const unsigned char* key=0);
	// Data should always be aligned to a 64 bit multiple
	// If not, discard the junk (hence force the caller to paddle...)
	void encrypt(unsigned char* data, const unsigned long length);
	void decrypt(unsigned char* data, const unsigned long length);
};
